# encoding: utf-8
# language: ja
@javascript
機能: operators_length - 「変数:(　)の長さ」ブロック
  背景:
    前提 "ブロック" タブを表示する

  シナリオ: ブロックのみ配置する
    もし 次のブロックを配置する:
    """
    %block{:type => "operators_length", :x => "0", :y => "0"}
    """
    かつ ブロックからソースコードを生成する

    ならば テキストエディタのプログラムは以下を含むこと:
      """
      "".length
      """

  シナリオ: 値を設定したブロックを配置する
    もし 次のブロックを配置する:
    """
    %block{:type => "operators_length", :x => "0", :y => "0"}
      %value{:name => "A"}
        %block{:type => "text"}
          %field{:name => "TEXT"}<
            こんにちは
    """
    かつ ブロックからソースコードを生成する

    ならば テキストエディタのプログラムは以下を含むこと:
      """
      "こんにちは".length
      """

  シナリオ: 文と値を設定したブロックを配置する
    もし 次のブロックを配置する:
    """
    %block{:type => "ruby_p", :x => "0", :y => "0", :inline => "true"}
      %value{:name => "ARG"}
        %block{:type => "operators_length"}
          %value{:name => "A"}
            %block{:type => "text"}
              %field{:name => "TEXT"}<
                こんにちは
    """
    かつ ブロックからソースコードを生成する

    ならば テキストエディタのプログラムは以下を含むこと:
      """
      p("こんにちは".length)
      """
