# encoding: utf-8
# language: ja
@javascript
機能: Load - プログラムのロード
  シナリオ: プログラムを読み込む
    前提 "Ruby" タブを表示する

    もし "files/01.rb" をロードする
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば テキストエディタに "files/01.rb" を読み込むこと
    かつ "プログラム名の入力欄" は "01.rb" であること
    かつ テキストエディタの 0 行目の 0 文字目にカーソルがあること
    かつ テキストエディタにフォーカスがあること
    かつ "メッセージ" に "ロードしました" を含むこと

  シナリオ: プログラムを入力済み状態でプログラムを読み込む
    前提 "Ruby" タブを表示する
    かつ テキストエディタに "puts 'Hello, World!'" を入力済みである

    もし "files/01.rb" をロードする
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば テキストエディタに "files/01.rb" を読み込むこと
    かつ "プログラム名の入力欄" は "01.rb" であること
    かつ テキストエディタの 0 行目の 0 文字目にカーソルがあること
    かつ テキストエディタにフォーカスがあること
    かつ "メッセージ" に "ロードしました" を含むこと

  シナリオ: 間違って画像を読み込もうとする
    前提 "Ruby" タブを表示する

    もし "files/favicon.ico" をロードする
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば テキストエディタのプログラムは "" であること
    かつ "プログラム名の入力欄" は "" であること
    かつ "メッセージ" に "favicon.icoはRubyのプログラムではありません" を含むこと
    かつ "メッセージ" に "ロードしました" を含まないこと

  シナリオ: プログラムを修正後にロードボタンを押す
    前提 "Ruby" タブを表示する
    かつ テキストエディタに "puts 'Hello, World!'" を入力済みである

    もし サブメニューの "ロードボタン" をクリックする

    ならば 確認メッセージ "まだセーブしていないのでロードするとプログラムが消えてしまうよ！\nそれでもロードしますか？" を表示すること

  シナリオ: プログラムを修正後にダウンロードしてからロードボタンを押す
    前提 "Ruby" タブを表示する
    かつ テキストエディタに "puts 'Hello, World!'" を入力済みである
    かつ プログラムの名前に "01.rb" を指定する
    かつ "ダウンロードボタン" をクリックする
    かつ JavaScriptによるリクエストが終わるまで待つ
    かつ ダウンロードが完了するまで待つ
    かつ 実際にはファイルをロードしないようにしておく

    もし サブメニューの "ロードボタン" をクリックする

    ならば 確認メッセージを表示しないこと

  シナリオ: プログラムを修正後にプログラムをロードしてからロードボタンを押す
    前提 "Ruby" タブを表示する
    かつ テキストエディタに "puts 'Hello, World!'" を入力済みである
    かつ "files/01.rb" をロードする
    かつ JavaScriptによるリクエストが終わるまで待つ
    かつ 実際にはファイルをロードしないようにしておく

    もし サブメニューの "ロードボタン" をクリックする

    ならば 確認メッセージを表示しないこと

  シナリオ: プログラムを修正後に間違って画像をロードしてからロードボタンを押す
    前提 "Ruby" タブを表示する
    かつ テキストエディタに "puts 'Hello, World!'" を入力済みである
    かつ "files/favicon.ico" をロードする
    かつ JavaScriptによるリクエストが終わるまで待つ

    もし サブメニューの "ロードボタン" をクリックする

    ならば 確認メッセージ "まだセーブしていないのでロードするとプログラムが消えてしまうよ！\nそれでもロードしますか？" を表示すること
