# encoding: utf-8
# language: ja
@javascript
@standalone
機能: Save - プログラムのセーブ(standaloneモード)
  シナリオ: セーブボタンを押してローカルマシンにプログラムを保存できる
    前提 "Ruby" タブを表示する
    かつ テキストエディタに "puts 'Hello, World!'" を入力済みである
    かつ プログラムの名前に "01.rb" を指定する

    もし サブメニューの "セーブボタン" をクリックする
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば ホームディレクトリに "01.rb" が存在すること
    かつ ホームディレクトリの "01.rb" の内容が "puts 'Hello, World!'" であること
    かつ "メッセージ" に "セーブしました" を含むこと

  シナリオ: ローカルマシンに同じ名前のプログラムがある状態でセーブボタンを押して上書き保存する
    前提 "Ruby" タブを表示する
    かつ ホームディレクトリに "puts 'Hello, World!'" という内容の "01.rb" が存在する
    かつ テキストエディタに "n = 0" を入力済みである
    かつ プログラムの名前に "01.rb" を指定する

    もし サブメニューの "セーブボタン" をクリックする
    かつ JavaScriptによるリクエストが終わるまで待つ
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば 確認メッセージ "前に01.rbという名前でセーブしているけど本当にセーブしますか？\nセーブすると前に作成したプログラムは消えてしまうよ！" を表示すること
    かつ "メッセージ" に "セーブしました" を含むこと
    かつ ホームディレクトリの "01.rb" の内容が "n = 0" であること

  シナリオ: ローカルマシンに同じ名前のプログラムがある状態でセーブボタンを押すが、キャンセルして上書き保存をしない
    前提 "Ruby" タブを表示する
    かつ ホームディレクトリに "puts 'Hello, World!'" という内容の "01.rb" が存在する
    かつ テキストエディタに "n = 0" を入力済みである
    かつ プログラムの名前に "01.rb" を指定する
    かつ 確認ダイアログをキャンセルするようにしておく

    もし サブメニューの "セーブボタン" をクリックする
    かつ JavaScriptによるリクエストが終わるまで待つ
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば 確認メッセージ "前に01.rbという名前でセーブしているけど本当にセーブしますか？\nセーブすると前に作成したプログラムは消えてしまうよ！" を表示すること
    かつ "メッセージ" に "セーブをキャンセルしました" を含むこと
    かつ ホームディレクトリの "01.rb" の内容が "puts 'Hello, World!'" であること

  シナリオテンプレート: ブロックモードでセーブボタンを押してローカルマシンにプログラムを保存できる
    前提 "ブロック" タブを表示する
    かつ 次のキャラクターを追加する:
      | name | costumes |   x |   y | angle |
      | car1 | car4.png  | 300 | 200 |    90 |
    かつ 次のブロックを配置する:
      """
      %block{:type => "character_new", :x => "0", :y => "0"}
        %field{:name => "NAME"}<
          car1
        %statement{:name => "DO"}
          %block{:type => "motion_move", :x => "0", :y => "0"}
            %value{:name => "STEP"}
              %block{:type => "math_number"}
                %field{:name => "NUM"}<
                  10
      """
    かつ プログラムの名前に "<プログラムの名前>" を指定する

    もし サブメニューの "セーブボタン" をクリックする
    かつ JavaScriptによるリクエストが終わるまで待つ

    ならば "メッセージ" に "セーブしました" を含むこと
    かつ ホームディレクトリに "<保存したファイルの名前>" が存在すること
    かつ ホームディレクトリの "<保存したファイルの名前>" が次の内容であること:
      """
      <xml xmlns="http://www.w3.org/1999/xhtml">
        <character x="300" y="200" name="car1" costumes="costume1:car4.png" angle="90"></character>
        <block type="character_new" id="1" x="0" y="0">
          <field name="NAME">car1</field>
          <statement name="DO">
            <block type="motion_move" id="2" inline="true">
              <value name="STEP">
                <block type="math_number" id="3">
                  <field name="NUM">10</field>
                </block>
              </value>
            </block>
          </statement>
        </block>
      </xml>
      """

    例:
      | プログラムの名前 | 保存したファイルの名前 |
      | 01.rb            | 01.rb.xml              |
      | 01.xml           | 01.rb.xml              |
      | 01.rb.xml        | 01.rb.xml              |
      | 01               | 01.rb.xml              |

